
public class BTNode implements Position
{
	private Object element;
	private BTNode parent;
	private BTNode leftChild;
	private BTNode rightChild;
	
	public BTNode( Object o )
	{
		element = o;
		leftChild = rightChild = parent = null;
	}
	
	public BTNode( Object o, BTNode l, BTNode r )
	{
		element = o;
		leftChild = l;
		rightChild = r;
		parent = null;
	}
	
	public BTNode( Object o, BTNode l, BTNode r, BTNode p )
	{
		element = o;
		leftChild = l;
		rightChild = r;
		parent = p;
	}
	
	public void setElement( Object o )
	{
		element = o;
	}
	
	public void setLeft( BTNode l )
	{
		leftChild = l;
	}
	
	public void setRight( BTNode r )
	{
		rightChild = r;
	}
	
	public void setParent( BTNode p )
	{
		parent = p;
	}
	
	public Object getElement()
	{
		return element;
	}
	
	public BTNode getLeft()
	{
		return leftChild;
	}
	
	public BTNode getRight()
	{
		return rightChild;
	}
	
	public BTNode getParent()
	{
		return parent;
	}
	
}