
public interface BinaryTree
{
	public int size();
	public boolean isEmpty();
	public boolean isInternal( Position p );
	public boolean isExternal( Position p );
	public boolean isRoot( Position p );
	public boolean hasLeft( Position p );
	public boolean hasRight( Position p );
	public Position root();
	public Position left( Position p );
	public Position right( Position p );
	public Position parent( Position p );
	public Object getElement( Position p );
	public Position sibling( Position p );
	// replaces element at position p, returns previous contents
	public Object replace( Position p, Object o );
	public Position addRoot( Object e ) throws NodeExistsException;
	public Position insertLeft( Position p, Object e ) throws NodeExistsException;
	public Position insertRight( Position p, Object e ) throws NodeExistsException;
	// remove a leaf node, return object originally at that node
	public Object remove( Position p ) throws NotALeafException;	
}